"use strict";
this.name			= "OXPAdditionalCargoSpaceWorkaround Script";
this.author			= "ocz";
this.copyright		= "2015 ocz";
this.licence		= "CC BY-NC-SA 4.0";
this.version		= "0.1"

this.OXPACSWCargoSpace = 0;
this.OXPACSWManifestRestoreNeeded = false;
this.OXPACSWEquipmentRestoreNeeded = false;
this.OXPACSWPassengersOnList = 0;
this.OXPACSWManifest = "";
this.OXPACSWEquipment = "";
this.OXPACSWPassengers = "";

if (!OXPACSWCrossScriptList) var OXPACSWCrossScriptList = [];
OXPACSWCrossScriptList.push(this.name);

this.OXPACSWCalculate = function () {			// Recalculates to size of the cargo hold and takes OXP added cargo space into the calculation.
	
	var _shipSpace = 0;
	if (Ship.shipDataForKey(player.ship.dataKey)["max_cargo"]) _shipSpace = parseInt(Ship.shipDataForKey(player.ship.dataKey)["max_cargo"]);
	
	if (player.ship.equipmentStatus("EQ_CARGO_BAY") === "EQUIPMENT_OK") {
		if (Ship.shipDataForKey(player.ship.dataKey)["extra_cargo"] > 0) {
			_shipSpace += Ship.shipDataForKey(player.ship.dataKey)["extra_cargo"];
		}
		else _shipSpace += 15; // Standard value for "extra_cargo" (Cobra MkIII)
	}
	
	var _equipmentWeight = 0;
	var _eqKey = "";
	for (var i = 0; i < player.ship.equipment.length; i++) {
		_eqKey = player.ship.equipment[i].equipmentKey;
		_equipmentWeight += player.ship.equipment[i].requiredCargoSpace;
	}

	var _passengerBerthWeight;
	if (player.ship.passengerCapacity >0) _passengerBerthWeight = 5 * (player.ship.passengerCapacity-1);
	else _passengerBerthWeight = 0;

	player.ship.cargoSpaceCapacity = _shipSpace + this.OXPACSWCargoSpace - _passengerBerthWeight - _equipmentWeight;
	
	if (this.OXPACSWManifestRestoreNeeded) this.OXPACSWRestoreManifest();	// Restores any changes made to the number of commodities by the game engine. 
	if (this.OXPACSWEquipmentRestoreNeeded) this.OXPACSWRestoreEquipment();
	if (missionVariables.OXPACSW_ship_passenger_list) this.OXPACSWRestorePassengers();
}
	

this.OXPACSWAddCargoSpace = function (_amount) {
	
	this.OXPACSWCargoSpace += _amount;
}

this.OXPACSWDecreaseAddedCargoSpace = function (_amount) {			// Implemented, because of reasons.
	
	if (this.OXPACSWCargoSpace <= _amount) this.OXPACSWCargoSpace = 0; //Doesn't decrease to a negative value.
	else this.OXPACSWCargoSpace -= _amount;
}

this.OXPACSWAdjustCargo = function(inputCommodity, inputAmount, inputUnit) {	// Sets commodities in the cargo hold to a certain amount.

	var _amount = inputAmount;
	if (_amount < 0) _amount = 0;

	if (inputUnit === "g") {
		var _tons = Math.round(_amount/1000000);
		player.ship.manifest[inputCommodity] = 0;
		if (_tons > player.ship.cargoSpaceAvailable) {
			_amount =  (player.ship.cargoSpaceAvailable * 1000000) + 499999;
			log("OXPACSW: Not enough space for " + inputAmount + inputUnit + " " + inputCommodity + ". Setting to " + _amount + inputUnit + ".");
		}
	}
	else if (inputUnit === "kg") {
		var _tons = Math.round(_amount/1000);
		player.ship.manifest[inputCommodity] = 0;
		if (_tons > player.ship.cargoSpaceAvailable) {
			_amount =  (player.ship.cargoSpaceAvailable * 1000) + 499;
			log("OXPACSW: Not enough space for " + inputAmount + inputUnit + " " + inputCommodity + ". Setting to " + _amount + inputUnit + ".");
		}
	}
	else if ((_amount - player.ship.manifest[inputCommodity]) > player.ship.cargoSpaceAvailable) {
		_amount = player.ship.cargoSpaceAvailable + player.ship.manifest[inputCommodity];
		log("OXPACSW: Not enough space for " + inputAmount + inputUnit + " " + inputCommodity + ". Setting to " + _amount + inputUnit + ".");
	}
	player.ship.manifest[inputCommodity] = _amount;
	return true;
}
	
this.OXPACSWRestoreManifest = function() {			// Parses a missionVariable to restore commodities from it.

	if (this.OXPACSWManifest != "" && this.OXPACSWManifestRestoreNeeded) {
		var _shipManifestList = this.OXPACSWManifest;
		var i, _s;
		var _case = "";
		var _commodity = "";
		var _quantity = "";
		var _unit = "";
		
		for (i = 0; i < _shipManifestList.length; i++) {
			if (_shipManifestList[i] == "{" ) {
				i++;
				if (i+1 < _shipManifestList.length) _case = _shipManifestList[i];
				i += 2;
				_s = "";
				while (i < _shipManifestList.length && _shipManifestList[i] != "}") {
					_s += _shipManifestList[i];
					i++;
				}
				if (_case === "I") _commodity = _s;
				else if (_case === "Q") _quantity = _s;
				else if (_case === "U") _unit = _s;
			}
			else if (_shipManifestList[i] == "]" ) {
				if (	_commodity != "" &&
						_quantity != "" &&
						_unit != "") {
					log(_commodity + _quantity + _unit);
					this.OXPACSWAdjustCargo(_commodity, _quantity, _unit);	// Sets the commodities in the cargo hold here.
					_commodity = "";
					_quantity = "";
					_unit = "";
				}
			}
		}
	}
}

this.OXPACSWSaveManifest = function () {  // Creates a missionVariable to store the commodities in the cargo hold.
	
	var _OXPACSWManifestList = "---Do NOT edit this line!---(" + player.ship.cargoSpaceUsed + ")[";
	var _mList = player.ship.manifest.list;
	var _m, i;
	for (i = 0; i < _mList.length; i++)
	{
		_m = _mList[i];
		_OXPACSWManifestList += "[{I:" + _m.commodity /*+ "}{N:" +_m.displayName + "}{C:" + _m.containers */+ "}{Q:" + _m.quantity  + "}{U:" +  _m.unit  + "}]";
	}
	_OXPACSWManifestList += "]";
	missionVariables.OXPACSW_ship_manifest_list = _OXPACSWManifestList;
}

this.OXPACSWRestoreEquipment = function() {			// Parses a missionVariable to restore equipment from it.
	if (this.OXPACSWEquipment != "") {
		var _shipEquipmentList = this.OXPACSWEquipment;
		var i, _s;
		var _case = "";
		var _eqKey = "";
		var _status = "";
		var _amount = "";
		
		var _overlooked = [];
		var _overlookedProp = [];
		
		for (i = 0; i < _shipEquipmentList.length; i++) {
			if (_shipEquipmentList[i] == "{" ) {
				i++;
				if (i+1 < _shipEquipmentList.length) _case = _shipEquipmentList[i];
				i += 2;
				_s = "";
				while (i < _shipEquipmentList.length && _shipEquipmentList[i] != "}") {
					_s += _shipEquipmentList[i];
					i++;
				}
				if (_case === "K") _eqKey = _s;
				else if (_case === "S") _status = _s;
				else if (_case === "A") _amount = _s;
			}
			else if (_shipEquipmentList[i] == "]" ) {
				if (	_eqKey != "" &&
						_status != "") {
					if (_eqKey != "EQ_PASSENGER_BERTH" && player.ship.equipmentStatus(_eqKey) != "EQUIPMENT_OK" && player.ship.equipmentStatus(_eqKey) != "EQUIPMENT_DAMAGED") {
						if (!player.ship.canAwardEquipment(_eqKey) && (EquipmentInfo.infoForKey(_eqKey).requiredCargoSpace <= player.ship.cargoSpaceAvailable)){
							// In case an item can't be added, because it requires other items, that haven't been installed just at this point, its key and status are written into both _overlooked arrays.
							if (EquipmentInfo.infoForKey(_eqKey).requiresAnyEquipment || EquipmentInfo.infoForKey(_eqKey).requiresEquipment) {
								if (_overlooked.indexOf(_eqKey) === -1) { //Checks if the item is already in the list.
									_overlooked.push(_eqKey);
									_overlookedProp.push(_status);							
								}
							}
						}
						else player.ship.awardEquipment(_eqKey);
					}
					if (_eqKey === "EQ_PASSENGER_BERTH") {
						if (_amount === "") _amount = "0";
						for (var j = player.ship.passengerCapacity; j < parseInt(_amount); j++)
							player.ship.awardEquipment(_eqKey);
					}
					_eqKey = "";
					_status = "";
					_amount = "";
				}
				// If there are items stored in the _overlooked arrays, the following loop will try to award them until either the array is empty or no item could be awarded any more.
				if (_overlooked.length > 0) {
					var _oLength = 0;
					while (_oLength != _overlooked.length) {
						_oLength = _overlooked.length;
						for (var j = 0; j < _overlooked.length; j++) {
							if (player.ship.canAwardEquipment(_overlooked[j])) {
								player.ship.awardEquipment(_overlooked[j]);
								player.ship.setEquipmentStatus(_overlooked[j],_overlookedProp[j]);
								_overlooked.splice(j,1);
								_overlookedProp.splice(j,1);
							}
						}
					}
				}
				if (_overlooked.length > 0) {
					var _errorMessage = "OXPACSW: The equipment";
					if (_overlooked.length > 1) _errorMessage += "s";
					for (var j = 0; j < _overlooked.length; j++) {
						_errorMessage += " ''" + _overlooked[j] + "''";
					}
					_errorMessage += "couldn't be installed."
					log(_errorMessage);
				}
			}
		}
	}
}	


this.OXPACSWSaveEquipment = function () {  // Creates a missionVariable to store the equipment of the ship.

	var _OXPACSWEquipmentList = "---Do NOT edit this line!---[";
	var _eList = player.ship.equipment;
	var _e, i;
	var _maxWeight = 0;
	for (i = 0; i < _eList.length; i++)
	{
		_e = _eList[i];
		_OXPACSWEquipmentList += "[{K:" + _e.equipmentKey + "}{S:" + player.ship.equipmentStatus(_e.equipmentKey) +"}";
		if (_e.equipmentKey === "EQ_PASSENGER_BERTH") _OXPACSWEquipmentList += "{A:" +  player.ship.passengerCapacity + "}";
		_OXPACSWEquipmentList += "]";
		if (_maxWeight < _e.requiredCargoSpace) _maxWeight = _e.requiredCargoSpace;
	}
	_OXPACSWEquipmentList += "]";
	
	if (_maxWeight > 0) {
		missionVariables.OXPACSW_ship_equipment_maxWeight = _maxWeight;
		missionVariables.OXPACSW_ship_equipment_list = _OXPACSWEquipmentList;
	}
	else {
		if (missionVariables.OXPACSW_ship_equipment_maxWeight) delete missionVariables.OXPACSW_ship_equipment_maxWeight;
		if (missionVariables.OXPACSW_ship_equipment_list) delete missionVariables.OXPACSW_ship_equipment_list;
	}
}

this.OXPACSWRestorePassengers = function() {			// Parses a missionVariable to restore the passenger list from it.

	if (this.OXPACSWPassengersOnList > player.ship.passengers.length) {
		var _shipPassengerList = this.OXPACSWPassengers;
		var i, _s;
		var _case = "";
		var _eta = "";
		var _name = "";
		var _start = "";
		var _destination = "";
		var _fee = "";
		var _premium = "";
		var _risk = "";
		for (i = 0; i < _shipPassengerList.length; i++) {
			if (_shipPassengerList[i] == "{" ) {
				i++;
				if (i+1 < _shipPassengerList.length) _case = _shipPassengerList[i];// + _shipPassengerList[i+1];
				
				
				i += 2;
				_s = "";
				while (i < _shipPassengerList.length && _shipPassengerList[i] != "}") {
					_s += _shipPassengerList[i];
					i++;
				}
				if (_case === "E") _eta = _s;
				else if (_case === "N") _name = _s;
				else if (_case === "S") _start = _s;
				else if (_case === "D") _destination = _s;
				else if (_case === "F") _fee = _s;
				else if (_case === "P") _premium = _s;
				else if (_case === "R") _risk = _s;
				log(_case + _s);
			}
			else if (_shipPassengerList[i] == "]" ) {
				if (	_eta != "" &&
						_name != "" &&
						_start != "" &&
						_destination != "" &&
						_fee != "" &&
						_premium != "" &&
						_risk != "") {
					var _alreadyAboard = false;
					for (var j = 0; j < player.ship.passengers.length; j++) {
						if (_name === player.ship.passengers[j].name) _alreadyAboard = true;  //Checks only the name. Additional checks might be necessary.
					}
					if (!_alreadyAboard) player.ship.addPassenger(_name, _start, _destination, clock.seconds + parseInt(_eta), _fee, _premium, _risk);	// Adds the passenger.
					_case = "";
					_eta = "";
					_name = "";
					_start = "";
					_destination = "";
					_fee = "";
					_premium = "";
					_risk = "";
				}
			}
		}	
	}
}

this.OXPACSWSavePassengers = function () {  // Creates a missionVariable to store the passenger list.
	
	var _pList = player.ship.passengers;
	var _OXPACSWPassengerList = "---Do NOT edit this line!---(" + _pList.length + ")[";
	var _p, i;
	for (i = 0; i < _pList.length; i++)
	{
		_p = _pList[i];
		_OXPACSWPassengerList += "[{E:" + _p.eta + "}{N:" +_p.name + "}{S:" + _p.start + "}{D:" + _p.destination  + "}{F:" +  _p.fee  + "}{P:" +  _p.premium  + "}{R:" +  _p.risk  + "}]";
	}
	_OXPACSWPassengerList += "]";
	missionVariables.OXPACSW_ship_passenger_list = _OXPACSWPassengerList;
	missionVariables.OXPACSW_ship_passenger_amount = player.ship.passengers.length;
}

this.startUp = function () {
	
	delete this.startUp; 
	this.OXPACSWCargoSpace = 0;
	
	for (var i = 0; i < OXPACSWCrossScriptList.length; i++) {
		if (worldScripts[OXPACSWCrossScriptList[i]].OXPACSWaddPhase) 
			worldScripts[OXPACSWCrossScriptList[i]].OXPACSWaddPhase();
	}
	
	// Checks to see, if it might be necessary to restore the commodities from a missionVariable.
	if (player.ship.cargoSpaceAvailable <= 0) {							
		if (missionVariables.OXPACSW_ship_manifest_list != null) {
			this.OXPACSWManifest = missionVariables.OXPACSW_ship_manifest_list;
			this.OXPACSWManifestRestoreNeeded = true;
		}
	}
	else {
		this.OXPACSWManifest = "";
		this.OXPACSWManifestRestoreNeeded = false;
	}
	
	// Checks to see, if it might be necessary to restore equipment from a missionVariable.
	var _maxWeight = 0;
	
	if (missionVariables.OXPACSW_ship_equipment_maxWeight) _maxWeight = missionVariables.OXPACSW_ship_equipment_maxWeight;
		
	if (player.ship.cargoSpaceAvailable < _maxWeight) {
		this.OXPACSWEquipment = missionVariables.OXPACSW_ship_equipment_list;
		this.OXPACSWEquipmentRestoreNeeded = true;
	}
	else {
		this.OXPACSWEquipment = "";
		this.OXPACSWEquipmentRestoreNeeded = false;
	}
	
	// Checks to see, if it might be necessary to restore the passenger list from a missionVariable.
	if (missionVariables.OXPACSW_ship_passenger_amount) this.OXPACSWPassengersOnList = missionVariables.OXPACSW_ship_passenger_amount;
	if (missionVariables.OXPACSW_ship_passenger_list) this.OXPACSWPassengers = missionVariables.OXPACSW_ship_passenger_list;
	
	this.OXPACSWCalculate();
}

this.playerWillSaveGame = function () {
	
	// Check if the ship manifest has to be backuped.
	if (this.OXPACSWCargoSpace > player.ship.cargoSpaceAvailable) this.OXPACSWSaveManifest();
	else if (missionVariables.OXPACSW_ship_manifest_list) delete missionVariables.OXPACSW_ship_manifest_list;
	
	//Check if the equipment has to be backuped.
	var _weight;
	var _sumWeight = 0;
	
	for (var i = 0; i < player.ship.equipment.length; i++) {
		_weight = player.ship.equipment[i].requiredCargoSpace;
		if (_weight > 0) {
			if (_sumWeight < _weight) _sumWeight += _weight;
		}
	}
	if (this.OXPACSWCargoSpace > _sumWeight) this.OXPACSWSaveEquipment();
	else {
		if (missionVariables.OXPACSW_ship_equipment_list) delete missionVariables.OXPACSW_ship_equipment_list;
		if (missionVariables.OXPACSW_ship_equipment_maxWeight) delete missionVariables.OXPACSW_ship_equipment_maxWeight;
	}
	
	//Check if the passenger list has to be backuped.
	if (this.OXPACSWCargoSpace > (player.ship.passengers.length * 5)) {
		this.OXPACSWSavePassengers();
	}
	else {
		if (missionVariables.OXPACSW_ship_passenger_list) delete missionVariables.OXPACSW_ship_passenger_list;
		if (missionVariables.OXPACSW_ship_passenger_amount) delete missionVariables.OXPACSW_ship_passenger_amount;
	}
	

}